#
#	OBSOLETE DECEMBER 2000 -- Replaced by design whereby we have a
#	separate .cod file for input and output encodings, e.g., roman2.cod
#	and roman2o.cod.
#
#	Convert the first column of a .cod file from hex to %03d decimal,
#	and reformat into a .ps encoding vector, using "TeX ad hoc" encoding
#	method for 7-bit fonts (double-encodes glyphs from 0x0 to 0x32 to
#	various upper 128 positions, forces "space" at position 32, moves
#	code 32 glyph to upper-128 position).
#
#	Copyright 1996 Richard J. Kinch
#	Kinch, March 1995, February 1996
#
BEGIN {
    for (i=0; i<256; i++) name[i] = ".notdef"
    code_max = 128			# assume 7-bit font
    SPACE_CODE = 32
#
#	"TeX ad hoc" remappings
#
    map[0] = 161
    map[1] = 162
    map[2] = 163
    map[3] = 164
    map[4] = 165
    map[5] = 166
    map[6] = 167
    map[7] = 168
    map[8] = 169
    map[9] = 170
    map[10] = 173
    map[11] = 174
    map[12] = 175
    map[13] = 176
    map[14] = 177
    map[15] = 178
    map[16] = 179
    map[17] = 180
    map[18] = 181
    map[19] = 182
    map[20] = 183
    map[21] = 184
    map[22] = 185
    map[23] = 186
    map[24] = 187
    map[25] = 188
    map[26] = 189
    map[27] = 190
    map[28] = 191
    map[29] = 192
    map[30] = 193
    map[31] = 194
    map[32] = 195
    map[127] = 196
#
#	Hex to decimal conversion table
#
    val["0"] = 0
    val["1"] = 1
    val["2"] = 2
    val["3"] = 3
    val["4"] = 4
    val["5"] = 5
    val["6"] = 6
    val["7"] = 7
    val["8"] = 8
    val["9"] = 9
    val["a"] = 10
    val["A"] = 10
    val["b"] = 11
    val["B"] = 11
    val["c"] = 12
    val["C"] = 12
    val["d"] = 13
    val["D"] = 13
    val["e"] = 14
    val["E"] = 14
    val["f"] = 15
    val["F"] = 15
    printf "/Encoding 256 array\n"
    printf "0 1 255 {1 index exch /.notdef put} for\n"
    }
# Load all codes
{
d1 = substr($1,1,1)
d2 = substr($1,2,1)
if ($2!=".notdef") {
    i = val[d1]*16+val[d2]
    name[i] = $2
    if (i>=128) code_max = 256;
    }
}
END {
# Prepend upper-128 remappings if this is a 7-bit font
    if (code_max==128) for (i=0; i<128; i++) if (map[i]) {
	if (name[i]!~/^.notdef$/) printf "dup %d /%s put\n",map[i],name[i]
	}
# Write out mappings
    for (i=0; i<code_max; i++) if (i==SPACE_CODE || name[i]!~/^.notdef$/) {
	printf "dup %d /%s put\n",i,(i==SPACE_CODE)?"space":name[i]
	}
    printf "readonly def\n"
    }
